// Code specific to the finite field of 7 elements

static char add_table[Q][Q] = {
        {0, 1, 2, 3, 4, 5, 6},
        {1, 2, 3, 4, 5, 6, 0},
        {2, 3, 4, 5, 6, 0, 1},
        {3, 4, 5, 6, 0, 1, 2},
        {4, 5, 6, 0, 1, 2, 3},
        {5, 6, 0, 1, 2, 3, 4},
        {6, 0, 1, 2, 3, 4, 5}
};

static char mul_table[Q][Q] = {
        {0, 0, 0, 0, 0, 0, 0},
        {0, 1, 2, 3, 4, 5, 6},
        {0, 2, 4, 6, 1, 3, 5},
        {0, 3, 6, 2, 5, 1, 4},
        {0, 4, 1, 5, 2, 6, 3},
        {0, 5, 3, 1, 6, 4, 2},
        {0, 6, 5, 4, 3, 2, 1}
};


const FFel FFel::elements[Q] = {FFel(0, true), FFel(1, true), FFel(2, true), FFel(3, true),
                                FFel(4, true), FFel(5, true), FFel(6, true)};

const int CHARACTERISTIC = 7;

constexpr int LOWERBOUNDB = 12;
constexpr int UPPERBOUNDMINB = 19;


