// Code specific to the finite field of 5 elements

static char add_table[Q][Q] = {
        {0, 1, 2, 3, 4},
        {1, 2, 3, 4, 0},
        {2, 3, 4, 0, 1},
        {3, 4, 0, 1, 2},
        {4, 0, 1, 2, 3}
};

static char mul_table[Q][Q] = {
        {0, 0, 0, 0, 0},
        {0, 1, 2, 3, 4},
        {0, 2, 4, 1, 3},
        {0, 3, 1, 4, 2},
        {0, 4, 3, 2, 1}
};

const FFel FFel::elements[Q] = { FFel(0, true), FFel(1, true), FFel(2, true), FFel( 3,  true), FFel(4, true) };

constexpr int CHARACTERISTIC = 5;

constexpr int LOWERBOUNDB = 9; // a set needs at least this number of points to be able to be a blocking set.
constexpr int UPPERBOUNDMINB = 12; // a MINIMAL blocking set has at most this amount of points.
